#!/bin/bash

#==============================================================================
#     (c) Copyright 2006, Hewlett-Packard, all rights reserved.
#
#     PACKAGE      HP OpenView OmniBack II
#     FILE         DPvmware_postexec.sh
#     RCS          $Header: /src/install/DPvmware_postexec.sh /main/dp60_fix/5 2008-05-14 07:11:52 palos $
#
#==============================================================================

ResumeSuspendedVMs()
{

echo "`/bin/date +%F-%H:%M:%S` Resuming the suspended VMs by the preexec script on the VMWare ESX server $HOST:" >> $file

#Now, we go through the list of VMs which should be resumed.
IFS=$'\n'
cat $LIST_RUNNING_VMS_TO_SUSPEND | while read VMS
do
echo "`/bin/date +%F-%H:%M:%S` $VMS" >> $file
running=`vmware-cmd $VMS getstate | awk '{print $3}'`
   return=$?
   if [ $return -ne 0 ] ; then
      echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to getstate of $VMS" >> $file
      exit 1
   fi
echo " `/bin/date +%F-%H:%M:%S` VM $VMS is in <$running> state" >> $file
if [ "$running" = "suspended" ]; then
    echo " `/bin/date +%F-%H:%M:%S` Let's resume the VM $VMS" >> $file
    #If a VM is indeed suspended then we resume it.
    /usr/bin/vmware-cmd $VMS start hard >> $file 2>> $file
    return=$?
    if [ $return -ne 0 ] ; then
       echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to suspend $VMS" >> $file
       exit 1
    fi
    sleep 1
else
    echo " `/bin/date +%F-%H:%M:%S` No need to resume the VM $VMS" >> $file
fi
done
}


HOST=`/bin/hostname`

if [ -d "/opt/omni/bin" ] && [ -s "/opt/omni/lbin/inet" ] ; then
SCRIPT_DIR=/opt/omni/bin
else
SCRIPT_DIR=/usr/omni/bin
fi

VERSION=`vmware -v | grep -i "VMware ESX Server 2" | wc -l`

LIST_RUNNING_VMS_TO_SUSPEND="/tmp/list_running_vms_to_suspend.tmp"
LIST_VMS_IN_HOT_TO_COMMIT="/tmp/list_running_vms_to_put_in_hot.tmp"
file=`cat /tmp/vmwaredebug`
echo "`/bin/date +%F-%H:%M:%S` DPVmware_postexec.sh script started" >> $file


#First we check the existence of the list of suspended VMs which should be resumed.
if [ -s $LIST_RUNNING_VMS_TO_SUSPEND ]; then
    ResumeSuspendedVMs
    `rm -f ${LIST_RUNNING_VMS_TO_SUSPEND}` > /dev/null 2>&1
else
    echo " `/bin/date +%F-%H:%M:%S` There are no suspended VMs to resume by the postexec script" >> $file
fi

if [ -s $LIST_VMS_IN_HOT_TO_COMMIT ]; then
cat $LIST_VMS_IN_HOT_TO_COMMIT | while read VMS
do
	IFS=$'\n'
	if [ -s ${VMS}.snapshot ]; then 
            `cp -p ${VMS}.snapshot $VMS` > /dev/null 2>&1	
	fi
done
fi

#Then we check the existence of the list of VMs in hot mode which should be committed.
if [ -s $LIST_VMS_IN_HOT_TO_COMMIT ]; then
	if [ $VERSION = 1 ]; then
          $SCRIPT_DIR/DPvmware_commitop.pl
	else
	  $SCRIPT_DIR/DPvmware_removesnapshot.pl
	  RETURN_VALUE=$?
	  if [ $RETURN_VALUE -ne 0 ]; then
	     echo " `/bin/date +%F-%H:%M:%S`  DPvmware_removesnapshot.pl Script failed. Not proceeding with the DP session." >> $file
	     #remove the copy of the vmx file created incase of snapshot creation failure
	     exit 1;
	  fi 
	fi
else
    echo "`/bin/date +%F-%H:%M:%S` There are no VMs in hot mode to commit by the postexec script" >> $file
fi

if [ -s $LIST_VMS_IN_HOT_TO_COMMIT ]; then
cat $LIST_VMS_IN_HOT_TO_COMMIT | while read VMS
do
	IFS=$'\n'
	if [ $VERSION -ne 1 ]; then 
		`rm -f ${VMS}.snapshot` > /dev/null 2>&1 
		`rm -f ${VMS}.bck` > /dev/null 2>&1 
	fi
	`rm -f ${LIST_VMS_IN_HOT_TO_COMMIT}` > /dev/null 2>&1
done
fi
echo "================================================" >> $file
echo "Debugging ended properly" >> $file
echo "================================================" >> $file

