#!/bin/bash

###############################################################################
#
#     (c) Copyright 2006, Hewlett-Packard NSMD, all rights reserved.
#
#     PACKAGE      HP OpenView OmniBackII
#     FILE         DPvmware_preexec.sh
#     RCS          $Header: /src/util/VMWareESX/DPvmware_preexec.sh /main/dp60_fix/5 2008-05-14 16:38:58 palos $
#
###############################################################################


SuspendAllVMs()
{

echo " `/bin/date +%F-%H:%M:%S` Suspending all running VMs on the VMWare ESX server $HOST:" >> $file

#First we prepare the list of running VMs which should be resumed later in the postexec script.
if [ -s $LIST_RUNNING_VMS_TO_SUSPEND ]; then
    rm -f $LIST_RUNNING_VMS_TO_SUSPEND > /dev/null 2>&1
fi

#Now, we identify all the running VMs and suspend them.
IFS=$'\n'
for VMS in `vmware-cmd -l` ; do
   running=`vmware-cmd $VMS getstate | awk '{print $3}'`
   return=$?
   if [ $return -ne 0 ] ; then
      echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to getstate of $VMS" >> $file
      exit 1
   fi

   echo "`/bin/date +%F-%H:%M:%S` VM $VMS is in <$running> state" >> $file
   if [ "$running" = "on" ]; then
       echo " `/bin/date +%F-%H:%M:%S` Let's suspend the VM $VMS" >> $file
      #If a VM is running then we put it in the list of running VMs and suspend it.
      echo "${VMS}" >> $LIST_RUNNING_VMS_TO_SUSPEND 2> /dev/null
      /usr/bin/vmware-cmd $VMS suspend hard >> $file 2>> $file
      return=$?
      if [ $return -ne 0 ] ; then
        echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to suspend $VMS" >> $file
	exit 1
      fi
      sleep 1
      echo "`/bin/date +%F-%H:%M:%S` VM $VMS suspended" >> $file
   else
       echo "`/bin/date +%F-%H:%M:%S` No need to suspend the VM $VMS" >> $file
   fi
done
}


SuspendSelectedVMs()
{
echo " `/bin/date +%F-%H:%M:%S` Suspending the selected VMs on the VMWare ESX server $HOST:" >> $file

#First we prepare the list of running VMs which should be resumed later in the postexec script.
if [ -s $LIST_RUNNING_VMS_TO_SUSPEND ]; then
    rm -f $LIST_RUNNING_VMS_TO_SUSPEND > /dev/null 2>&1
fi

#Now, we identify all the running VMs and suspend them.
IFS=$'\n'
for VMS in `vmware-cmd -l` ; do
   running=`vmware-cmd $VMS getstate | awk '{print $3}'`
   return=$?
   if [ $return -ne 0 ] ; then
      echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to getstate of $VMS" >> $file
      exit 1
   fi
IFS=$','
   for VMS_SELECTED in $VMS_TO_SUSPEND
   do
	VMS_SELECTED=`${SCRIPT_DIR}/DPvmware_vmmapping.pl $VMS_SELECTED`
        if [ "${VMS_SELECTED}" = "Cannot open file" ]; then
	    echo " `/bin/date +%F-%H:%M:%S` File open failed" >> $file
	    exit 1
	fi
	if [ "${VMS_SELECTED}" = "Wrong input" ]; then
	    echo "`/bin/date +%F-%H:%M:%S` Wrong Input entered in config file" >> $file
	    exit
	fi
      if [ "${VMS}" = "${VMS_SELECTED}" ]; then
         echo " `/bin/date +%F-%H:%M:%S` VM $VMS is in <$running> state" >> $file
         if [ "$running" = "on" ]; then
             echo " `/bin/date +%F-%H:%M:%S` Let's suspend the VM $VMS" >> $file
             #If a VM is running then we put it in the list of running VMs and suspend it.
             echo "${VMS}" >> $LIST_RUNNING_VMS_TO_SUSPEND 2> /dev/null
             /usr/bin/vmware-cmd $VMS suspend hard >> $file 2>> $file
             return=$?
             if [ $return -ne 0 ] ; then
                echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to suspend $VMS" >> $file
	        exit 1
             fi
             sleep 1
             echo " `/bin/date +%F-%H:%M:%S` VM $VMS suspended" >> $file
         else
             echo " `/bin/date +%F-%H:%M:%S` No need to suspend the VM $VMS" >> $file
         fi
      fi
   done
done
}


PutInHotAllVMs()
{

echo " `/bin/date +%F-%H:%M:%S` Putting in hot mode all running VMs on the VMWare ESX server $HOST:" >> $file

if [ -s $LIST_RUNNING_VMS_TO_PUT_IN_HOT ]; then
    rm -f $LIST_RUNNING_VMS_TO_PUT_IN_HOT > /dev/null 2>&1
fi

#Now, we identify all the running VMs and call the DPvmware_createsnapshot.pl/DPvmware_addredo.pl script which puts them in the hot mode.
IFS=$'\n'
for VMS in `vmware-cmd -l` ; do
   running=`vmware-cmd $VMS getstate | awk '{print $3}'`
   return=$?
   if [ $return -ne 0 ] ; then
      echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to getstate of $VMS" >> $file
      exit 1
   fi
   echo " `/bin/date +%F-%H:%M:%S` VM $VMS is in <$running> state" >> $file
   if [ "$running" = "on" ]; then
       echo "`/bin/date +%F-%H:%M:%S` Let's put the VM $VMSin hot mode" >> $file
   else
       echo " `/bin/date +%F-%H:%M:%S` No need to put the VM $VMS in hot mode" >> $file
   fi
   if [ "$running" = "on" ] ; then
      #If a VM is running then we put it in the hot mode.
	if [ $VERSION = 1 ]; then
	  $SCRIPT_DIR/DPvmware_addredo.pl $VMS
	  RETURN_VALUE=$?
	  if [ $RETURN_VALUE -ne 0 ]; then
	      echo "`/bin/date +%F-%H:%M:%S` DPvmware_addredo.pl Script failed. Not proceeding with the DP session." >> $file
	      #QXCM1000358754 - exiting with status = 1
	      exit 1;
	  fi
	else
	  `cp -p $VMS ${VMS}.bck` > /dev/null 2>&1
	  #check for the return value
          $SCRIPT_DIR/DPvmware_createsnapshot.pl $VMS 
	  RETURN_VALUE=$?
	  if [ $RETURN_VALUE -ne 0 ]; then
	     echo " `/bin/date +%F-%H:%M:%S`  DPvmware_createsnapshot.pl Script failed. Not proceeding with the DP session." >> $file
	     #remove the copy of the vmx file created incase of snapshot creation failure
	     `rm -f ${VMS}.bck` > /dev/null 2>&1
	     exit 1;
	  fi 
	fi
        sleep 1
	`cp -p $VMS ${VMS}.snapshot` > /dev/null 2>&1
	`cp -p ${VMS}.bck $VMS` > /dev/null 2>&1
        echo " `/bin/date +%F-%H:%M:%S` VM $VMSis now in hot mode." >> $file
   fi
done
}


PutInHotSelectedVMs()
{

echo " `/bin/date +%F-%H:%M:%S` Putting in hot mode the selected running VMs on the VMWare ESX server $HOST:" >> $file

if [ -s $LIST_RUNNING_VMS_TO_PUT_IN_HOT ]; then
	rm -f $LIST_RUNNING_VMS_TO_PUT_IN_HOT > /dev/null 2>&1
fi

#Now, we identify all the running VMs and call the DPvmware_createsnapshot.pl script which puts them in the hot mode.
IFS=$'\n'

for VMS in `vmware-cmd -l` ; do
   running=`vmware-cmd $VMS getstate | awk '{print $3}'`
   return=$?
   if [ $return -ne 0 ] ; then
      echo "`/bin/date +%F-%H:%M:%S` Vmware-cmd failed to getstate of $VMS" >> $file
      exit 1
   fi
IFS=$','
   for VMS_SELECTED in $VMS_IN_HOT_MODE
   do
	VMS_SELECTED=`${SCRIPT_DIR}/DPvmware_vmmapping.pl $VMS_SELECTED`
	if [ "${VMS_SELECTED}" = "Wrong input" ]; then
	    echo " `/bin/date +%F-%H:%M:%S` Wrong Input entered in config file" >> $file
	    exit
	fi
      if [ "${VMS}" = "${VMS_SELECTED}" ]; then
         echo " `/bin/date +%F-%H:%M:%S` VM $VMS is in <$running> state" >> $file
         if [ "$running" = "on" ]; then
             echo " `/bin/date +%F-%H:%M:%S` Let's put the VM $VMSin hot mode" >> $file
         else
             echo " `/bin/date +%F-%H:%M:%S` No need to put the VM $VMS in hot mode" >> $file
         fi
      fi
      if [ "$running" = "on" ] && \
         [ "${VMS}" = "${VMS_SELECTED}" ]; then
         #If a VM is running then we put it in the hot mode.
	 IFS=$'\n'
	if [ $VERSION = 1 ]; then
	   $SCRIPT_DIR/DPvmware_addredo.pl $VMS
	   RETURN_VALUE=$?
	   if [ $RETURN_VALUE -ne 0 ]; then
	      echo "`/bin/date +%F-%H:%M:%S` DPvmware_addredo.pl Script failed. Not proceeding with the DP session." >> $file
	      #QXCM1000358754 - exiting with status = 1
	      exit 1;
	   fi 
	   sleep 1
	   echo " `/bin/date +%F-%H:%M:%S` VM $VMS is now in hot mode" >> $file
	else
	  `cp -p $VMS ${VMS}.bck` > /dev/null 2>&1
	   # check for the return value 
	   $SCRIPT_DIR/DPvmware_createsnapshot.pl $VMS
	   RETURN_VALUE=$?
	   if [ $RETURN_VALUE -ne 0 ]; then
	      echo "`/bin/date +%F-%H:%M:%S` DPvmware_createsnapshot.pl Script failed. Not proceeding with the DP session."
	      # remove the copy of the vmx file created incase of snapshot creation failure 
	      `rm -f ${VMS}.bck` > /dev/null 2>&1
	      exit 1;
	   fi 
	   sleep 1
	   `cp -p $VMS ${VMS}.snapshot` > /dev/null 2>&1
	   `cp -p ${VMS}.bck $VMS` > /dev/null 2>&1
 	   echo " `/bin/date +%F-%H:%M:%S` VM $VMSis now in hot mode." >> $file
	   #/* post exec will handle the cleanup these files */
	fi
      fi
   done
done
}

#main part of script

HOST=`/bin/hostname`
TIMESTAMP=`/bin/date +%F-%H:%M:%S`
PROCNAME=$0
temp=`ps ax | grep $PROCNAME`
#pidno=`echo $temp | cut -d" " -f1`
pidno=`echo $temp | awk ' { print $1 }'`
file=/tmp/OB2DBG_${pidno}_${HOST}_${TIMESTAMP}_vmware_debug.txt
touch $file
touch /tmp/vmwaredebug
echo $file > /tmp/vmwaredebug
echo "====================================================" >> $file
echo "DEBUGGING STARTED" >> $file
echo "FILE: $file" >> $file
echo "PID: $pidno" >> $file
echo "Machine: `uname -a`" >> $file
echo "====================================================" >> $file

if [ -d "/opt/omni/bin" ] && [ -s "/opt/omni/lbin/inet" ] ; then
SCRIPT_DIR=/opt/omni/bin
CONF_DIR=/etc/opt/omni/client
echo "`/bin/date +%F-%H:%M:%S` ESX Server is running DP 6.0 or greater version" >> $file
else 
SCRIPT_DIR=/usr/omni/bin
CONF_DIR=/usr/omni/newconfig
echo "`/bin/date +%F-%H:%M:%S` ESX Server is running DP 5.5 version" >> $file
fi
# Getting the version information from ESX server.
VERSION=`vmware -v | grep -i "VMware ESX Server 2" | wc -l`
if [ $VERSION = 1 ]; then
  echo "`/bin/date +%F-%H:%M:%S` ${HOST} ESX SERVER is running version 2.x" >> $file
else
  echo "`/bin/date +%F-%H:%M:%S` ${HOST} ESX SERVER is running version 3.x" >> $file
fi

#special case of ESX2.5.* for DP 5.5
#Have to check for DP 6.0 and version ESX-2.5.*
if [ $VERSION = 1 ] && [ -s "/usr/omni/bin/inet" ] ; then
CONF_DIR=/usr/omni/bin/
fi


LIST_RUNNING_VMS_TO_SUSPEND="/tmp/list_running_vms_to_suspend.tmp"
LIST_RUNNING_VMS_TO_PUT_IN_HOT="/tmp/list_running_vms_to_put_in_hot.tmp"

. ${CONF_DIR}/DPvmware_config.sh

if [ -f $LIST_RUNNING_VMS_TO_SUSPEND ]; then 
	rm -f $LIST_RUNNING_VMS_TO_SUSPEND > /dev/null 2>&1
fi

if [ -f $LIST_RUNNING_VMS_TO_PUT_IN_HOT ]; then 
	rm -f $LIST_RUNNING_VMS_TO_PUT_IN_HOT > /dev/null 2>&1
fi

if  [ "${SUSPEND_ALL_VMS}" = "YES" ] && [ "${PUT_ALL_VMS_IN_HOT_MODE}" = "YES" ]; then
	echo "`/bin/date +%F-%H:%M:%S` This operation is not allowed,can't put VMs in suspended and Hot mode simultaneously"
	echo "`/bin/date +%F-%H:%M:%S` This operation is not allowed,can't put VMs in suspended and Hot mode simultaneously" >> $file
	echo "Debugging ended properly" >> $file
	exit
fi

if  [ "${SUSPEND_ALL_VMS}" = "YES" ]; then
    echo "`/bin/date +%F-%H:%M:%S` Suspending all the VM's..." >> $file
    SuspendAllVMs
else
    if [ -n "$VMS_TO_SUSPEND" ]; then
    SuspendSelectedVMs
    else
    echo "`/bin/date +%F-%H:%M:%S` No VMs to suspend entered in the DPvmware_config.sh file" >> $file
    fi
fi


if  [ "${PUT_ALL_VMS_IN_HOT_MODE}" = "YES" ]; then
    PutInHotAllVMs
else
    if [ -n "$VMS_IN_HOT_MODE" ]; then
    PutInHotSelectedVMs
    else
    echo "`/bin/date +%F-%H:%M:%S` No VMs to put in hot mode entered in the DPvmware_config.sh file" >> $file
    fi
fi
echo " `/bin/date +%F-%H:%M:%S` End of DPvmware_preexec.sh script" >> $file
echo "#############################################################" >> $file
